/* a link list program */
#include <stdio.h>
#ifndef NULL
#define MULL 0
#endif

/* link list structure */
struct list
{
	int ch;
	struct list *next_rec;
};

typedef struct list LIST;
typedef LIST *LISTPTR;

/*-----------------------*/

LISTPTR add_to_list(int,LISTPTR);
void show_list(LISTPTR);
void free_memory_list(LISTPTR);

/* add_to_list() */

LISTPTR add_to_list(int ch, LISTPTR first )
{
	LISTPTR 	new_rec = NULL; /*holds address of new record */
	LISTPTR prev_rec=NULL;   /*hold tmp pointer*/
	LISTPTR tmp_rec=NULL;

	new_rec = (LISTPTR)malloc(sizeof(LIST)); /*allocate memory */
	if (!new_rec)
	{
		printf("\nUnable to allocate memory\n");
		exit(1);
	}
	/* set new link's data */
	new_rec->ch = ch;
	new_rec->next_rec = NULL;
	if (first==NULL) /* adding first link to list */
	{
		first = new_rec;
		new_rec->next_rec = NULL; /* redundant but safe??? */
	}
	else
	{
		/* see if it goes before the first link */
		if (new_rec->ch <first->ch)
		{
			new_rec->next_rec=first;
			first = new_rec;
		}
		else /* it is being added to the middle or end */
		{
			tmp_rec = first->next_rec;
			prev_rec = first;
		/* Check to see where link is added. */
		if (tmp_rec ==NULL )
		{
			/* we are adding second record to end */
			prev_rec->next_rec = new_rec;
		}
		else
		{
			/* check to see if adding in middle */
			while ((tmp_rec->next_rec != NULL))
				{
					if (new_rec->ch <tmp_rec->ch)
						{
							new_rec->next_rec = tmp_rec;
							if (new_rec->next_rec != prev_rec->next_rec)
							{
								printf("ERROR");
								getc(stdin);
								exit(0);
							}
							prev_rec->next_rec = new_rec;
							break; /* link is added, exit while */
						}
					else
						{
							tmp_rec = tmp_rec ->next_rec;
							prev_rec = prev_rec->next_rec;
						}
				}
				/* check to see if anything to the end */
				if (tmp_rec->next_rec == NULL)
				{
					if (new_rec->ch <tmp_rec->ch) /* 1 before end */
					{
						new_rec->next_rec = tmp_rec;
						prev_rec->next_rec = new_rec;
					}
					else /* at the end */
					{
						tmp_rec->next_rec = new_rec;
						new_rec->next_rec = NULL; /* redundant */
					}
				}
			}
		}
	}
	return(first);
}
